var CHAR_MAP = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
var encode = function (input) {
    var str = String(input);
    var prx = [2, 4, 6, 8];
    var map = CHAR_MAP;
    var output = '';
    var block = 0;
    for (var i = 0, j = 0; i < str.length || 63 & block || (map = '=', j % 4 !== 0); i++) {
        var code = str.charCodeAt(i);
        var uarr = code > 0x7F ? encodeURI(str.charAt(i)).split('%').slice(1).map(function (c) { return parseInt(c, 16); }) : [code];
        for (var k = 0; k < uarr.length; k++) {
            block = block << 8 | uarr[k];
            output += map.charAt(63 & block >> prx[j % 4]);
            j++;
            if (j % 4 === 3) { // tail
                output += isNaN(uarr[k]) ? '=' : map.charAt(63 & block);
                j++;
                block = 0;
            }
        }
    }
    return output;
};
var decode = function (input) {
    var str = String(input);
    var prx = [6, 4, 2, 0];
    var map = CHAR_MAP.slice(0, -1);
    var output = '';
    var block = 0;
    var code;
    var buffer = 0;
    var hex = '';
    try {
        for (var i = 0; (code = map.indexOf(str[i])) > -1; i++) {
            block = block << 6 | code;
            if (i % 4) {
                buffer = 255 & block >> prx[i % 4];
                if (buffer < 128) {
                    output += hex ? decodeURI(hex) : '';
                    output += String.fromCharCode(buffer);
                    hex = '';
                }
                else {
                    hex += '%' + ('0' + buffer.toString(16)).slice(-2);
                }
            }
        }
        output += hex ? decodeURI(hex) : '';
        return output;
    }
    catch (err) {
        throw new Error('base64 malformed!');
    }
};
var base64 = {
    encode: encode,
    decode: decode,
};

export { base64 as default };
